/****************    ARQUIVO   STRUCT.H   ***************************/
typedef struct TYP_FILA {
          char 	*nome; /*nome da fila*/
          int 	n_tot; /*numero total de clientes que passaram*/
          int 	n_cour; /*numero atual de clientes*/
          int 	n_max; /*numero maximo de clientes ocorrido*/
          float	t_sim_ant; /*tempo de simulacao do evento anterior*/
          int 	n_tam_ant; /*numero de clientes do evento anterior*/
          float tot_tam_acum; /*tamanho da fila acumulada*/
	  struct TYP_SERVIDOR *saida; /*ponteiro para estrutura de servidores*/
          }FILA;

typedef struct TYP_SERVIDOR {
          int 	tipo; /*tipo de servico -EXPON ou UNIF*/
          char 	*nome; /*nome do servidor*/
          flag 	fregues; /*cliente no servico ->0:nao,1:sim*/
          float t_proc_medio; /*media do servico exponencial*/
	  float t_proc_inf; /*limite inferior servico uniforme*/
	  float	t_proc_sup; /*limite superior servico uniforme*/
          float t_ocupado; /*tempo de servico do cliente atual*/
          float t_tot_ocupado; /*tempo que passou ocupado*/
          int 	n_tot; /*numero total de clientes servidos*/
	  struct TYP_FILA *entrada; /*ponteiro p/ estrut. das filas*/
          struct TYP_FILA *saida; /*ponteiro p/ estrut. das filas*/
          }SERVIDOR;

typedef struct TYP_FONTE {
          int 	tipo; /*tipo de servico -EXPON ou UNIF*/
          char 	*nome; /*nome da fonte*/
          int 	n_tot; /*numero total de clientes gerados*/
          float t_proc_medio; /*media de geracao exponencial*/    
	  float t_proc_inf; /*limite inferior geracao uniforme*/  
	  float t_proc_sup; /*limite superior geracao uniforme*/  
          struct TYP_FILA *saida; /*ponteiro para estrutura das filas*/
          }FONTE;

typedef struct TYP_EVENT {
	  float t_event; /*tempo simulado de ocorrencia do proximo evento*/
	  int 	tipo; /*0-SERVIDOR , 1-FONTE*/
	  union 	{
			struct TYP_SERVIDOR *servidor;
			struct TYP_FONTE *fonte;
			} objeto;
	  struct 	TYP_EVENT *next;
	  struct 	TYP_EVENT *prec;
	  }EVENT;
